// PROJECT  :WireLevelRTC
// PURPOSE  :Stage 3 of the Wire-level I2C Introduction for TEI3M
// AUTHOR   :C. D'Arcy
// DATE     :2020 02 13
// uC       :328p
// HARDWARE :DS1307 Breakout and LCD Appliance
// STATUS   :(Not) Working
// REFERENCE:http://darcy.rsgc.on.ca/ACES/TEI3M/WireLevelRTCExercises.html#time

#include <Wire.h>
#define RTCADDRESS 0x00           //DS1307 I2C Address

#include <LiquidCrystal.h>        //LCD Library...
#define LCD_COLUMNS 16            //Number of columns in Character LCD screen
#define LCD_ROWS    2             //Number of rows on LCD screen
//LCD appliance-compatible pin assignments...
uint8_t RS = 7, EN = 6, D4 = 5, D5 = 4, D6 = 3, D7 = 2;
LiquidCrystal lcd(RS, EN, D4, D5, D6, D7);

char buff[LCD_COLUMNS];           //convenient output buffer for formatted prints

struct timeDate {                 //tight-binding of RTC register data into a struct
  uint8_t seconds;
  uint8_t minutes;
  uint8_t hours;
  uint8_t date;
  uint8_t mon;
  uint8_t YEAR;
} tD;


void setup() {
  lcd.begin(LCD_COLUMNS, LCD_ROWS);       //initialize LCD screen
  lcd.clear();                            //erase the LCD screen
  lcd.setCursor(0, 0);                    //position display cursor at home
  lcd.print("DATE:");                     //provide a label on the first line
  lcd.setCursor(0, 1);                    //position display cursor at start of second row
  lcd.print("TIME:");                     //provide a label on the second line

  pinMode(A2, OUTPUT);                    //provide supply for
  pinMode(A3, OUTPUT);                    // the DS1307 breakout board
  digitalWrite(A2, LOW);                  // inserted as an appliance
  digitalWrite(A3, HIGH);                 //

  Wire.begin();                           //initialize a Wire session
}

uint8_t BCD2bin(uint8_t bcd) {
  return 0;                                //compose an expression that converts BCD to binary
}

//the body of this method needs to be developed...
void getAll(timeDate &td) {

}

void loop() {
  Wire.beginTransmission(RTCADDRESS);
  Wire.write(0);
  Wire.endTransmission();
  Wire.requestFrom(RTCADDRESS, 7);
  //while (!Wire.available());
  getAll(tD);
  sprintf(buff, "%2d/%02d/%02d", tD.date, tD.mon, tD.YEAR);
  lcd.setCursor(5, 0);
  lcd.print(buff);
  sprintf(buff, "%02d:%02d:%02d", tD.hours, tD.minutes, tD.seconds);
  lcd.setCursor(5, 1);
  lcd.print(buff);
  delay(1000);
}
